Imports System.Math
Public Class clsMID

    Public mbytTrackData() As Byte, mlngTrackPos As Long, msngDeltaTime As Single

    Sub New()
        ReDim mbytTrackData(32767)
        mlngTrackPos = 0
        msngDeltaTime = 0
    End Sub

    Protected Overrides Sub Finalize()
        mbytTrackData = Nothing
        mlngTrackPos = Nothing
        msngDeltaTime = Nothing
    End Sub

    Structure Commands
        Structure NoteOff
            Const Command As Byte = &H80
            Dim Channel As Byte
            Dim Note As Byte
            Dim Velocity As Byte
        End Structure
        Structure NoteOn
            Const Command As Byte = &H90
            Dim Channel As Byte
            Dim Note As Byte
            Dim Velocity As Byte
        End Structure
        'Structure NoteAftertouch ' Not yet implemented
        '    Const Command As Byte = &HA0
        '    ' Not yet implemented
        'End Structure
        Structure ControllerChange
            Const Command As Byte = &HB0
            Dim Channel As Byte
            Dim Controller As Byte
            Dim ControllerValue As Byte
        End Structure
        Structure ProgramChange
            Const Command As Byte = &HC0
            Dim Channel As Byte
            Dim Program As Byte
        End Structure
        'Structure ChannelAftertouch ' Not yet implemented
        '    Const Command As Byte = &HD0
        '    'Not yet implemented
        'End Structure
        Structure PitchWheel
            Const Command As Byte = &HE0
            Dim Channel As Byte
            Function SetMSB(ByVal mshtWheel As Short) As Byte
                Dim shtMSB As Short = Fix(mshtWheel \ &H80) And &H7F
                Return CByte(shtMSB)
            End Function
            Function SetLSB(ByVal mshtWheel As Short) As Byte
                Dim shtLSB As Short = (mshtWheel And &H7F)
                Return CByte(shtLSB)
            End Function
            Dim MSB As Byte
            Dim LSB As Byte
        End Structure
        Structure MetaEvent
            Const Command As Byte = &HFF
            Dim foo As Byte
            Structure EndOfTrack
                Const Command As Byte = &H2F
                Const Data As Byte = &H0
                Dim foo As Byte
            End Structure
        End Structure
        Dim foo As Byte
    End Structure

    Enum Controllers
        ModulatorWheel = 1
        DataEntry = 6
        Volume = 7
        Pan = 10
        Sustain = 64
        LegatoPedal = 68
        Hold2Pedal = 69
        SoundTimbre = 71
        SoundReleaseTime = 72
        SoundAttackTime = 73
        SoundBrightness = 74
        RPNFine = 100
        RPNCoarse = 101
        AllControllersOff = 123
        AllNotesOff = 123
    End Enum

    Enum ControllerValues
        'Volume
        VolumeMin = &H0
        VolumeMax = &H7F
        'Pan
        PanLeft = &H0
        PanRight = &H7F
        PanCenter = &H3F
        'PitchWheel
        PitchWheelMin = &H0
        PitchWheelMax = &H3FFF
        PitchWheelCenter = &H1FFF
    End Enum

    Enum RPNs
        PitchBendRange = 0
    End Enum

    Enum Programs
        AcousticGrandPiano = 0
        BrightAcousticPiano = 1
        ElectricGrandPiano = 2
        HonkyTonkPiano = 3
        RhodesPiano = 4
        ChorusedPiano = 5
        Harpsichord = 6
        Clavinet = 7
        Celesta = 8
        Glockenspiel = 9
        MusicBox = 10
        Vibraphone = 11
        Marimba = 12
        Xylophone = 13
        TubularBells = 14
        Dulcimer = 15
        HammondOrgan = 16
        PercussiveOrgan = 17
        RockOrgan = 18
        ChurchOrgan = 19
        ReedOrgan = 20
        Accordion = 21
        Harmonica = 22
        TangoAccordion = 23
        AcousticGuitarNylon = 24
        AcousticGuitarSteel = 25
        ElectricGuitarJazz = 26
        ElectricGuitarClean = 27
        ElectricGuitarMuted = 28
        OverdrivenGuitar = 29
        DistortionGuitar = 30
        GuitarHarmonics = 31
        AcousticBass = 32
        ElectricBassFinger = 33
        ElectricBassPick = 34
        FretlessBass = 35
        SlapBass1 = 36
        SlapBass2 = 37
        SynthBass1 = 38
        SynthBass2 = 39
        Violin = 40
        Viola = 41
        Cello = 42
        Contrabass = 43
        TremoloStrings = 44
        PizzicatoStrings = 45
        OrchestralHarp = 46
        Timpani = 47
        StringEnsemble1 = 48
        StringEnsemble2 = 49
        SynthStrings1 = 50
        SynthStrings2 = 51
        ChoirAhhs = 52
        VoiceOohs = 53
        SynthVoice = 54
        OrchestraHit = 55
        Trumpet = 56
        Trombone = 57
        Tuba = 58
        MutedTrumpet = 59
        FrenchHorn = 60
        BrassSection = 61
        SynthBrass1 = 62
        SynthBrass2 = 63
        SopranoSax = 64
        AltoSax = 65
        TenorSax = 66
        BaritoneSax = 67
        Oboe = 68
        EnglishHorn = 69
        Bassoon = 70
        Clarinet = 71
        Piccolo = 72
        Flute = 73
        Recorder = 74
        PanFlute = 75
        BottleBlow = 76
        Shakuhachi = 77
        Whistle = 78
        Ocarina = 79
        Lead1Square = 80
        Lead2Sawtooth = 81
        Lead3Calliope = 82
        Lead4Chiff = 83
        Lead5Changarang = 84
        Lead6Voice = 85
        Lead7Fifths = 86
        Lead8BassLead = 87
        Pad1NewAge = 88
        Pad2Warm = 89
        Pad3Polysynth = 90
        Pad4Choir = 91
        Pad5Bowed = 92
        Pad6Metallic = 93
        Pad7Halo = 94
        Pad8Sweep = 95
        FX1Rain = 96
        FX2Soundtrack = 97
        FX3Crystal = 98
        FX4Atmosphere = 99
        FX5Brightness = 100
        FX6Goblins = 101
        FX7Echoes = 102
        FX8Scifi = 103
        Sitar = 104
        Banjo = 105
        Shamisen = 106
        Koto = 107
        Kalimba = 108
        Bagpipe = 109
        Fiddle = 110
        Shanai = 111
        TinkleBell = 112
        Agogo = 113
        SteelDrums = 114
        Woodblock = 115
        TaikoDrum = 116
        MelodicTom = 117
        SynthDrum = 118
        ReverseCymbal = 119
        GuitarFretNoise = 120
        BreathNoise = 121
        Seashore = 122
        BirdTweet = 123
        TelephoneRing = 124
        Helicopter = 125
        Applause = 126
        Gunshot = 127
    End Enum

    Enum Percussion
        AcousticBassDrum = 35
        BassDrum1 = 36
        SideStick = 37
        AcousticSnare = 38
        HandClap = 39
        ElectricSnare = 40
        LowFloorTom = 41
        ClosedHiHat = 42
        HighFloorTom = 43
        PedalHiHat = 44
        LowTom = 45
        OpenHiHat = 46
        LowMidTom = 47
        HiMidTom = 48
        CrashCymbal1 = 49
        HighTom = 50
        RideCymbal1 = 51
        ChineseCymbal = 52
        RideBell = 53
        Tambourine = 54
        SplashCymbal = 55
        Cowbell = 56
        CrashCymbal2 = 57
        Vibraslap = 58
        RideCymbal2 = 59
        HiBongo = 60
        LowBongo = 61
        MuteHiConga = 62
        OpenHiConga = 63
        LowConga = 64
        HiTimbale = 65
        LowTimbale = 66
        HighAgogo = 67
        LowAgogo = 68
        Cabasa = 69
        Maracas = 70
        ShortWhistle = 71
        LongWhistle = 72
        ShortGuiro = 73
        LongGuiro = 74
        Claves = 75
        HiWoodBlock = 76
        LowWoodBlock = 77
        MuteCuica = 78
        OpenCuica = 79
        MuteTriangle = 80
        OpenTriangle = 81
    End Enum

    Private Sub AddDeltaTime()
        If msngDeltaTime >= 128 Then
            Do Until msngDeltaTime < 128
                Dim i As Integer = mbytTrackData.GetUpperBound(0)
                If mlngTrackPos > i Then
                    ReDim Preserve mbytTrackData(i + 32767)
                End If
                mbytTrackData(mlngTrackPos) = 128
                mlngTrackPos += 1
                msngDeltaTime -= 128
            Loop
        End If
    End Sub
    Overloads Sub AddEvent(ByVal NoteOff As Commands.NoteOff)
        AddDeltaTime()
        Dim i As Integer = mbytTrackData.GetUpperBound(0)
        If mlngTrackPos + 3 > i Then
            ReDim Preserve mbytTrackData(i + 32767)
        End If
        mbytTrackData(mlngTrackPos) = msngDeltaTime
        With NoteOff
            mbytTrackData(mlngTrackPos + 1) = (.Command Or .Channel)
            mbytTrackData(mlngTrackPos + 2) = .Note
            mbytTrackData(mlngTrackPos + 3) = .Velocity
        End With
        mlngTrackPos += 4
        msngDeltaTime = 0
    End Sub
    Overloads Sub AddEvent(ByVal NoteOn As Commands.NoteOn)
        AddDeltaTime()
        Dim i As Integer = mbytTrackData.GetUpperBound(0)
        If mlngTrackPos + 3 > i Then
            ReDim Preserve mbytTrackData(i + 32767)
        End If
        mbytTrackData(mlngTrackPos) = msngDeltaTime
        With NoteOn
            mbytTrackData(mlngTrackPos + 1) = (.Command Or .Channel)
            mbytTrackData(mlngTrackPos + 2) = .Note
            mbytTrackData(mlngTrackPos + 3) = .Velocity
        End With
        mlngTrackPos += 4
        msngDeltaTime = 0
    End Sub
    Overloads Sub AddEvent(ByVal ControllerChange As Commands.ControllerChange)
        AddDeltaTime()
        Dim i As Integer = mbytTrackData.GetUpperBound(0)
        If mlngTrackPos + 3 > i Then
            ReDim Preserve mbytTrackData(i + 32767)
        End If
        mbytTrackData(mlngTrackPos) = msngDeltaTime
        With ControllerChange
            mbytTrackData(mlngTrackPos + 1) = (.Command Or .Channel)
            mbytTrackData(mlngTrackPos + 2) = .Controller
            mbytTrackData(mlngTrackPos + 3) = .ControllerValue
        End With
        mlngTrackPos += 4
        msngDeltaTime = 0
    End Sub
    Overloads Sub AddEvent(ByVal ProgramChange As Commands.ProgramChange)
        AddDeltaTime()
        Dim i As Integer = mbytTrackData.GetUpperBound(0)
        If mlngTrackPos + 2 > i Then
            ReDim Preserve mbytTrackData(i + 32767)
        End If
        mbytTrackData(mlngTrackPos) = msngDeltaTime
        With ProgramChange
            mbytTrackData(mlngTrackPos + 1) = (.Command Or .Channel)
            mbytTrackData(mlngTrackPos + 2) = .Program
        End With
        mlngTrackPos += 3
        msngDeltaTime = 0
    End Sub
    Overloads Sub AddEvent(ByVal PitchWheel As Commands.PitchWheel)
        AddDeltaTime()
        Dim i As Integer = mbytTrackData.GetUpperBound(0)
        If mlngTrackPos + 3 > i Then
            ReDim Preserve mbytTrackData(i + 32767)
        End If
        mbytTrackData(mlngTrackPos) = msngDeltaTime
        With PitchWheel
            mbytTrackData(mlngTrackPos + 1) = (.Command Or .Channel)
            mbytTrackData(mlngTrackPos + 2) = .LSB
            mbytTrackData(mlngTrackPos + 3) = .MSB
        End With
        mlngTrackPos += 4
        msngDeltaTime = 0
    End Sub
    Overloads Sub AddEvent(ByVal MetaEvent As Commands.MetaEvent)
        AddDeltaTime()
        ReDim Preserve mbytTrackData(mlngTrackPos + 3)
        mbytTrackData(mlngTrackPos) = msngDeltaTime
        mbytTrackData(mlngTrackPos + 1) = &HFF
        mbytTrackData(mlngTrackPos + 2) = &H2F
        mbytTrackData(mlngTrackPos + 3) = &H0
    End Sub

    Public Function toNote(ByVal Hz As Double) As Double
        If Hz = 0 Then
            Return 0
        Else
            Return (((Log10(Hz) - Log10(440)) / (Log10(2 ^ (1 / 12)))) + 69)
        End If
    End Function

    Public Function ChangePitch(ByVal Note1 As Double, ByVal Note2 As Double, _
        ByVal Channel As Byte, ByRef Note As Byte, ByRef PitchWheel As Short, _
        Optional ByVal ForceNewNote As Boolean = False) As Integer

        If ForceNewNote = True Then
            NewNote(Note1, Note2, Channel, Note, PitchWheel)
        End If

        Dim dblTestValue As Double = PitchWheel + ((Note2 - Note1) * 4096)

        Select Case dblTestValue
            Case ControllerValues.PitchWheelMin To ControllerValues.PitchWheelMax
                PitchWheel = CShort(dblTestValue)
                Dim Wheel As New Commands.PitchWheel()
                With Wheel
                    .Channel = Channel
                    .MSB = .SetMSB(PitchWheel) : .LSB = .SetLSB(PitchWheel)
                End With
                AddEvent(Wheel)
            Case Else
                NewNote(Note1, Note2, Channel, Note, PitchWheel)
        End Select
        Return 0
    End Function

    Public Function NewNote(ByVal Note1 As Double, ByVal Note2 As Double, _
        ByVal Channel As Byte, ByRef Note As Byte, ByRef PitchWheel As Short) As Integer

        Dim dblPitchWheel As Double = (Note2 - Fix(Note2))
        Note2 = Abs(Fix(Note2))
        If dblPitchWheel >= 0.5 Then
            Note2 += 1
            dblPitchWheel -= 1
        End If
        PitchWheel = ControllerValues.PitchWheelCenter + (dblPitchWheel * 4096)
        Dim NoteOff As Commands.NoteOff
        With NoteOff
            .Channel = Channel : .Note = Note : .Velocity = 0
        End With
        AddEvent(NoteOff)
        Dim Wheel As Commands.PitchWheel
        With Wheel
            .Channel = Channel
            .MSB = .SetMSB(PitchWheel) : .LSB = .SetLSB(PitchWheel)
        End With
        AddEvent(Wheel)
        Note = Note2
        Dim NoteOn As Commands.NoteOn
        With NoteOn
            .Channel = Channel : .Note = Note : .Velocity = &H7F
        End With
        AddEvent(NoteOn)
        Return 0
    End Function

    Public Function SaveFile(ByVal strFileName As String, _
        Optional ByVal intRate As Integer = 60) As Integer
        ' Add Track End marker
        Dim MetaEvent As New Commands.MetaEvent()
        AddEvent(MetaEvent)

        ' Initialize MIDI file header ("MThd")
        Dim MThd() As Byte = {Asc("M"), Asc("T"), Asc("h"), Asc("d")}
        Dim HeaderLen() As Byte = {0, 0, 0, 6}
        Dim MIDIFormat() As Byte = {0, 0}
        Dim NumTracks() As Byte = {0, 1}
        Dim numTicks(1) As Byte
        If intRate = 50 Then
            numTicks(0) = 0
            numTicks(1) = 25 'PAL/SECAM (50 Hz)
        Else
            numTicks(0) = 0
            numTicks(1) = 29 'NTSC (60 Hz)
        End If

        ' Initialize Track header ("MTrk")
        Dim MTrk() As Byte = {Asc("M"), Asc("T"), Asc("r"), Asc("k")}
        Dim intTrackLen As Integer = mbytTrackData.GetLength(0)
        Dim intByte0 As Integer = Fix(intTrackLen \ &H1000000) And &HFF
        Dim intByte1 As Integer = Fix(intTrackLen \ &H10000) And &HFF
        Dim intByte2 As Integer = Fix(intTrackLen \ &H100) And &HFF
        Dim intByte3 As Integer = Fix(intTrackLen And &HFF)

        Dim TrackLen() As Byte = {intByte0, intByte1, intByte2, intByte3}

        Try
            FileOpen(1, strFileName, OpenMode.Binary)
            FileClose(1)
            Kill(strFileName)

            FileOpen(1, strFileName, OpenMode.Binary)
            FilePut(1, MThd)
            FilePut(1, HeaderLen)
            FilePut(1, MIDIFormat)
            FilePut(1, NumTracks)
            FilePut(1, numTicks)
            FilePut(1, MTrk)
            FilePut(1, TrackLen)
            FilePut(1, mbytTrackData)
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            FileClose(1)
        End Try
    End Function

End Class